-- raid icons
RIB_RAIDICON_FILE = "Interface\\TargetingFrame\\UI-RaidTargetingIcons";
RIB_RAIDFLARE_FILES = {};
RIB_RAIDFLARE_FILES[1] = "Interface\\AddOns\\RaidIconBar\\marker\\blue";
RIB_RAIDFLARE_FILES[2] = "Interface\\AddOns\\RaidIconBar\\marker\\green";
RIB_RAIDFLARE_FILES[3] = "Interface\\AddOns\\RaidIconBar\\marker\\purple";
RIB_RAIDFLARE_FILES[4] = "Interface\\AddOns\\RaidIconBar\\marker\\red";
RIB_RAIDFLARE_FILES[5] = "Interface\\AddOns\\RaidIconBar\\marker\\yellow";
RIB_RAIDFLARE_FILES[6] = "Interface\\AddOns\\RaidIconBar\\marker\\orange";
RIB_RAIDFLARE_FILES[7] = "Interface\\AddOns\\RaidIconBar\\marker\\silver";
RIB_RAIDFLARE_FILES[8] = "Interface\\AddOns\\RaidIconBar\\marker\\white";

SCALE = 0.5;

function raidIconClicked(self, button, down)
    local index = self:GetAttribute("index");

    if (button == "LeftButton") then
        SetRaidTarget("target", index);
    elseif (button == "RightButton") then
        SetRaidTarget("target", 0);
    end
end

function createRaidIconBar()
    local raidicons = CreateFrame("Frame", "RIB_ChatRaidIcons", UIParent);
    raidicons:SetSize(130, 23);
    raidicons:SetScale(SCALE);
    raidicons:SetFrameStrata("DIALOG");

    for index=1, 8, 1 do
        local posx = (index - 5.5) * 50;

        local btn = CreateFrame("Button", "RIB_CHAT_RAIDFLARE_"..index, raidicons, "SecureActionButtonTemplate, ActionButtonTemplate");

        btn.NormalTexture:SetTexture(nil);
        btn.PushedTexture:SetTexture(nil);
		btn.SlotBackground:SetTexture(nil);

        btn.icon:SetTexture(RIB_RAIDICON_FILE);
        local left = mod((index-1)/4, 1);
        local right = left + 0.25;
        local top = floor((index-1)/4) * 0.25;
        local bottom = top + 0.25;
        btn.icon:SetTexCoord(left, right, top, bottom);

        btn:ClearAllPoints();
        btn:SetPoint("RIGHT", raidicons, "RIGHT", posx, 0);

        btn:SetAttribute("index", index);

        btn:RegisterForClicks("AnyUp");
        btn:HookScript("OnClick", raidIconClicked);
    end

    RaidIconBar_ResetRaidIconPosition();
end

function createRaidFlareBar()
    local raidflares = CreateFrame("Frame", "RIB_ChatRaidFlares", UIParent);
    raidflares:SetSize(130, 23);
    raidflares:SetScale(SCALE);
    raidflares:SetFrameStrata("DIALOG");

    for index=1, 8, 1 do
        local posx = (index - 5.5) * 50;

        local btn = CreateFrame("Button", "RIB_CHAT_RAIDFLARE_"..index, raidflares, "SecureActionButtonTemplate, ActionButtonTemplate");

        btn.NormalTexture:SetTexture(nil);
        btn.PushedTexture:SetTexture(nil);
		btn.SlotBackground:SetTexture(nil);

        btn.icon:SetTexture(RIB_RAIDFLARE_FILES[index]);

        btn:RegisterForClicks("AnyUp");
        btn:SetAttribute("type1", "macro");
        btn:SetAttribute("macrotext1", "/worldmarker "..index);
        btn:SetAttribute("type2", "macro");
        btn:SetAttribute("macrotext2", "/clearworldmarker "..index);

        btn:ClearAllPoints();
        btn:SetPoint("RIGHT", raidflares, "RIGHT", posx, 0);

        btn:SetAttribute("index", index);
    end

    RaidIconBar_ResetRaidFlarePosition();
end

function RaidIconBar_RaidIconSnap()
    if (InCombatLockdown()) then
        return;
    end

    if (_G["RIB_ChatRaidIcons"] == nil) then
        createRaidIconBar();
    end

    local frame = _G["RIB_ChatRaidIcons"];

    icons_posx = frame:GetLeft();
    icons_posy = frame:GetBottom();

    local x, y = GetCursorPosition();
    local scale = UIParent:GetEffectiveScale();

    x = x / scale / SCALE;
    y = y / scale / SCALE;

    frame:ClearAllPoints();
    frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x, y);
end

function RaidIconBar_ResetRaidIconPosition()
    local frame = _G["RIB_ChatRaidIcons"];

    if (frame) then
        frame:ClearAllPoints();
        frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", 100000, 0);
    end
end

function RaidIconBar_RaidFlareSnap()
    if (InCombatLockdown()) then
        return;
    end

    if (_G["RIB_ChatRaidFlares"] == nil) then
        createRaidFlareBar();
    end

    local frame = _G["RIB_ChatRaidFlares"];

    icons_posx = frame:GetLeft();
    icons_posy = frame:GetBottom();

    local x, y = GetCursorPosition();
    local scale = UIParent:GetEffectiveScale();

    x = x / scale / SCALE;
    y = y / scale / SCALE;

    frame:ClearAllPoints();
    frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x, y);
end

function RaidIconBar_ResetRaidFlarePosition()
    local frame = _G["RIB_ChatRaidFlares"];

    if (frame) then
        frame:ClearAllPoints();
        frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", 100000, 0);
    end
end
